

import javax.print.DocFlavor;
import java.awt.font.FontRenderContext;
import java.util.*;

public class Shop {

    private String nameOfShop;
    private ArrayList<Customer> Customers = new ArrayList<Customer>();
    private ArrayList<Repository> Repositorys = new ArrayList<Repository>();
    private ArrayList<Good> Goods = new ArrayList<Good>();
    private ArrayList<Order> orders = new ArrayList<Order>();
    private int income = 0;
    private ArrayList<Discount> discounts = new ArrayList<>();

    public void addCustomer(Customer C) {
        Customers.add(C);
    }

    public ArrayList<Customer> getCustomers() {
        return Customers;
    }

    public void addRepository(Repository R) {
        Repositorys.add(R);
    }

    public ArrayList<Repository> getRepository() {
        return Repositorys;
    }

    public int getIncome() {
        return income;
    }

    public void setIncome(int income) {
        this.income = income;
    }

    public void addGood(Good g) {
        Goods.add(g);
    }

    public void increamentGood(Good good, int amount) {

        int d = Repositorys.size();

        Repository arr[] = new Repository[d];

        for (int i = 0; i < d; i++) {

            arr[i] = Repositorys.get(i);
        }
        Arrays.sort(arr, new SortbyFreeCapacity());

        for (Repository repository : arr) {
            if (repository.getFreeCapacity() > amount) {
                repository.addGood(good, amount);
                break;
            }

        }
    }

    static class SortbyFreeCapacity implements Comparator<Repository> {
        // Used for sorting in ascending order of
        // roll number
        public int compare(Repository a, Repository b) {
            return a.getFreeCapacity() - b.getFreeCapacity();
        }

    }
    // public void addDiscount(Discount d, Customer c){}
    // public HashMap<Good, Integer> getItemsSold(){};


    static class Repository {

        private int id;
        private int capacity;
        private int filledCapacity;

        private HashMap<Good, Integer> listOfGoodsinRepository = new HashMap<Good, Integer>();

        private Repository(int id, int capacity) {
            this.id = id;
            this.capacity = capacity;
            this.filledCapacity = 0;
        }

        public HashMap<Good, Integer> getListOfGoodsinRepository() {
            return listOfGoodsinRepository;
        }

        public void removeGood(Good good, int amount) {
            int remain;
            remain = listOfGoodsinRepository.get(good);

            if ((remain - amount) > 0) {
                listOfGoodsinRepository.replace(good, remain, remain - amount);
                filledCapacity = filledCapacity - amount;
            }
        }

        public void addGood(Good good, int amount) {
            if (listOfGoodsinRepository.containsKey(good)) {
                listOfGoodsinRepository.replace(good, listOfGoodsinRepository.get(good), listOfGoodsinRepository.get(good) + amount);

                filledCapacity += amount;


            } else {
                listOfGoodsinRepository.put(good, amount);
                filledCapacity += amount;
            }
        }

        public int getId() {
            return id;
        }

        public int getCapacity() {
            return capacity;
        }

        public int getFreeCapacity() {
            return (capacity - filledCapacity);
        }

    }

    static class Good {
        private int id;
        private int price;
        private String name;

        public Good(int id, String name, int price) {
            this.id = id;
            this.name = name;
            this.price = price;
        }

        public int getId() {
            return id;
        }

        public int getPrice() {
            return price;
        }

        public String getName() {
            return name;
        }

    }

    static class Customer {

        private String name;
        private int ID;
        private int balance;
        ArrayList<Order> orders = new ArrayList<Order>();
        ArrayList<Order> pendingOrders = new ArrayList<Order>();
        ArrayList<Discount> discounts = new ArrayList<>();
        ArrayList <Order> submittedOrders = new ArrayList<>();
        public Customer(String name, int id) {
            this.name = name;
            this.ID = id;
        }

        public int getID() {
            return ID;
        }

        public String getName() {
            return name;
        }

        public int getBalance() {
            return balance;
        }

        public void setBalance(int amount) {
            balance = amount;
        }

        public void addorder(Order o) {
            orders.add(o);
        }

        public ArrayList<Order> getTOtalOrder() {
            return orders;
        }

        public ArrayList<Order> getPendingOrders() {
            return pendingOrders;
        }
        public ArrayList <Order> getSubmittedOrders (){return submittedOrders;}
        public void set


    }

    static class Order {
        private int ID;
        private String status;
        private Customer c;
        private Discount discount;
        HashMap<Good, Integer> Items = new HashMap<Good, Integer>();

        public Order(int id, Customer c) {
            ID = id;
            this.c = c;
            this.status = "pending";
        }

        public int getID() {
            return ID;
        }

        public String getStatus() {
            return status;
        }

        public HashMap<Good, Integer> getItems() {
            return Items;
        }

        public void setStatus(String status) {
            this.status = status;
        }

        public void addItem(Good good, int amount) {
            if (Items.containsKey(good)) {
                int Oldamount = Items.get(good);
                int Newamount = Oldamount + amount;
                Items.replace(good, Oldamount, Newamount);
            } else
                Items.put(good, amount);


        }

        public void removeItem(Good good) {
            Iterator<Good> it = Items.keySet().iterator();
            while (it.hasNext()) {
                Good sample = it.next();
                if (sample.getId() == good.getId()) it.remove();
            }
        }

        public void addDiscount(Discount discount) {
            this.discount = discount;
            c.discounts.add(discount);

        }

        public int getOrderPrice() {
            int price = 0;
            for (HashMap.Entry<Good, Integer> item: getItems().entrySet()) {
                price += item.getKey().price * item.getValue();
            }
            return price;
        }
    }

    static class Discount {
        //todo to compelete Discount class;
        private int id;
        private int percent;

        public Discount(int id, int percent) {
            this.id = id;
            this.percent = percent;
        }

        public int getId() {
            return id;
        }

        public int getPercent() {
            return percent;
        }

        public void setOrder(Order order) {

        }


    }

    public static void main(String[] args) {

        String entering;
        Shop MyShop = new Shop();
        Scanner scan = new Scanner(System.in);

        while (true) {
            entering = scan.nextLine();
            if (entering.equals("terminate")) return;
            if (entering.equals("add")) {
                String add = scan.nextLine();
                if (add.equals("customer")) {
                    int id = scan.nextInt();
                    String name = scan.nextLine();
                    Customer c = new Customer(name, id);
                    MyShop.addCustomer(c);
                }
                if (add.equals("good")) {

                    int id = scan.nextInt();

                    scan.nextLine();
                    String name = scan.nextLine();

                    int price = scan.nextInt();

                    int amount = scan.nextInt();


                    Good good = new Good(id, name, price);
                    MyShop.addGood(good);
                    MyShop.increamentGood(good, amount);


                }
                if (add.equals("repository")) {
                    int id = scan.nextInt();
                    int capacity = scan.nextInt();
                    Repository store = new Repository(id, capacity);
                    MyShop.addRepository(store);
                }
                if (add.equals("order")) {
                    int idOfOrder = scan.nextInt();
                    int idOfCustomer = scan.nextInt();
                    // Order order = new Order(idOfOrder);


                    Customer c = null;
                    for (Customer customer : MyShop.Customers)
                        if (customer.getID() == idOfCustomer) c = customer;
                    Order order = new Order(idOfOrder, c);
                    MyShop.orders.add(order);

                }
                if (add.equals("balance")) {
                    int IdOfCustomer = scan.nextInt();
                    int balance = scan.nextInt();
                    Customer c = null;
                    for (Customer customer : MyShop.Customers) {
                        if (customer.getID() == IdOfCustomer)
                        {
                            c = customer;
                            break;}
                    }
                    int OldBalance = c.getBalance();
                    int NewBalance = OldBalance + balance;
                    c.setBalance(NewBalance);
                }
                if (add.equals("item")) {
                    int idOfOrder = scan.nextInt();
                    int IdOfGood = scan.nextInt();
                    int NumberOfGood = scan.nextInt();
                    Good newgood = null;

                    for (Good good : MyShop.Goods)
                        if (good.getId() == IdOfGood) {
                            newgood = good;
                            break;

                        }

                    for (Order order : MyShop.orders) {

                        if (order.getID() == idOfOrder) {
                            order.addItem(newgood, NumberOfGood);
                        }

                    }

                }
                if (add.equals("discount")) {
                    int IdOfDiscount = scan.nextInt();
                    int Percent = scan.nextInt();
                    Discount discount = new Discount(IdOfDiscount, Percent);
                    MyShop.discounts.add(discount);


                }


            }

            if (entering.equals("report")) {
                // except customers others are complete;
                String report = scan.nextLine();

                if (report.equals("repositories")) {
                    for (Repository repo : MyShop.Repositorys) {
                        System.out.println(repo.id + "," + repo.capacity + "," + repo.getFreeCapacity());
                    }
                }
                if (report.equals("income")) {
                    System.out.println(MyShop.getIncome());
                }
                if (report.equals("customers")) ;

                {
                    for (Customer customer : MyShop.Customers) {

                        int total = customer.getTOtalOrder().size();
                        int pending = customer.getPendingOrders().size();
                        int submit = total - pending;
                        System.out.println(customer.getID() + "," + customer.getName() + "," + customer.getBalance() + "," + total + "," + submit);
                    }

                }
                if (entering.equals("submit")) {
                    String submit = scan.nextLine();
                    if (submit.equals("order")) {

                        int IdOfOrder = scan.nextInt();
                        Order neworder = null;

                        for (Order order : MyShop.orders) {

                            if (order.getID() == IdOfOrder) {
                                neworder = order;
                                break;
                            }


                        }


                    }
                    if (submit.equals("discount")) {
                        int IdOfOrder = scan.nextInt();
                        int IdOfDiscount = scan.nextInt();
                        Order neworder = null;
                        Discount newdiscount = null;
                        for (Order order : MyShop.orders) {
                            if (IdOfOrder == order.getID()) {
                                neworder = order;
                                break;
                            }


                        }
                        for (Discount discount : MyShop.discounts) {
                            if (discount.getId() == IdOfDiscount) {
                                newdiscount = discount;
                                break;
                            }
                        }

                        if (!neworder.c.discounts.contains(newdiscount))
                        {
                            neworder.addDiscount(newdiscount);
                        }


                    }
                }


            }

        }


    }
}



